Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x3.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x3.qrc	(revision 72722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x3.qrc	(revision 72723)
@@ -13,4 +13,5 @@
         <file alias="audio_16px_x3.png">images/x3/audio_16px_x3.png</file>
         <file alias="audio_all_off_16px_x3.png">images/x3/audio_all_off_16px_x3.png</file>
+        <file alias="audio_input_16px_x3.png">images/x3/audio_input_16px_x3.png</file>
         <file alias="audio_input_off_16px_x3.png">images/x3/audio_input_off_16px_x3.png</file>
         <file alias="audio_input_on_16px_x3.png">images/x3/audio_input_on_16px_x3.png</file>
@@ -199,4 +200,5 @@
         <file alias="hostkey_captured_16px_x3.png">images/x3/hostkey_captured_16px_x3.png</file>
         <file alias="hostkey_captured_pressed_16px_x3.png">images/x3/hostkey_captured_pressed_16px_x3.png</file>
+        <file alias="hostkey_pressed_16px_x3.png">images/x3/hostkey_pressed_16px_x3.png</file>
         <file alias="hostkey_warning_16px_x3.png">images/x3/hostkey_warning_16px_x3.png</file>
         <file alias="ide_16px_x3.png">images/x3/ide_16px_x3.png</file>
@@ -293,4 +295,17 @@
         <file alias="os_gentoo_x3.png">images/x3/os_gentoo_x3.png</file>
         <file alias="os_jrockitve_x3.png">images/x3/os_jrockitve_x3.png</file>
+        <file alias="os_l4_x3.png">images/x3/os_l4_x3.png</file>
+        <file alias="os_linux22_x3.png">images/x3/os_linux22_x3.png</file>
+        <file alias="os_linux24_64_x3.png">images/x3/os_linux24_64_x3.png</file>
+        <file alias="os_linux24_x3.png">images/x3/os_linux24_x3.png</file>
+        <file alias="os_linux26_64_x3.png">images/x3/os_linux26_64_x3.png</file>
+        <file alias="os_linux26_x3.png">images/x3/os_linux26_x3.png</file>
+        <file alias="os_linux_64_x3.png">images/x3/os_linux_64_x3.png</file>
+        <file alias="os_linux_x3.png">images/x3/os_linux_x3.png</file>
+        <file alias="os_macosx_64_x3.png">images/x3/os_macosx_64_x3.png</file>
+        <file alias="os_macosx_x3.png">images/x3/os_macosx_x3.png</file>
+        <file alias="os_mandriva_64_x3.png">images/x3/os_mandriva_64_x3.png</file>
+        <file alias="os_mandriva_x3.png">images/x3/os_mandriva_x3.png</file>
+        <file alias="os_netbsd_64_x3.png">images/x3/os_netbsd_64_x3.png</file>
     </qresource>
 </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x4.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x4.qrc	(revision 72722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox1_x4.qrc	(revision 72723)
@@ -13,4 +13,5 @@
         <file alias="audio_16px_x4.png">images/x4/audio_16px_x4.png</file>
         <file alias="audio_all_off_16px_x4.png">images/x4/audio_all_off_16px_x4.png</file>
+        <file alias="audio_input_16px_x4.png">images/x4/audio_input_16px_x4.png</file>
         <file alias="audio_input_off_16px_x4.png">images/x4/audio_input_off_16px_x4.png</file>
         <file alias="audio_input_on_16px_x4.png">images/x4/audio_input_on_16px_x4.png</file>
@@ -199,4 +200,5 @@
         <file alias="hostkey_captured_16px_x4.png">images/x4/hostkey_captured_16px_x4.png</file>
         <file alias="hostkey_captured_pressed_16px_x4.png">images/x4/hostkey_captured_pressed_16px_x4.png</file>
+        <file alias="hostkey_pressed_16px_x4.png">images/x4/hostkey_pressed_16px_x4.png</file>
         <file alias="hostkey_warning_16px_x4.png">images/x4/hostkey_warning_16px_x4.png</file>
         <file alias="ide_16px_x4.png">images/x4/ide_16px_x4.png</file>
@@ -293,4 +295,17 @@
         <file alias="os_gentoo_x4.png">images/x4/os_gentoo_x4.png</file>
         <file alias="os_jrockitve_x4.png">images/x4/os_jrockitve_x4.png</file>
+        <file alias="os_l4_x4.png">images/x4/os_l4_x4.png</file>
+        <file alias="os_linux22_x4.png">images/x4/os_linux22_x4.png</file>
+        <file alias="os_linux24_64_x4.png">images/x4/os_linux24_64_x4.png</file>
+        <file alias="os_linux24_x4.png">images/x4/os_linux24_x4.png</file>
+        <file alias="os_linux26_64_x4.png">images/x4/os_linux26_64_x4.png</file>
+        <file alias="os_linux26_x4.png">images/x4/os_linux26_x4.png</file>
+        <file alias="os_linux_64_x4.png">images/x4/os_linux_64_x4.png</file>
+        <file alias="os_linux_x4.png">images/x4/os_linux_x4.png</file>
+        <file alias="os_macosx_64_x4.png">images/x4/os_macosx_64_x4.png</file>
+        <file alias="os_macosx_x4.png">images/x4/os_macosx_x4.png</file>
+        <file alias="os_mandriva_64_x4.png">images/x4/os_mandriva_64_x4.png</file>
+        <file alias="os_mandriva_x4.png">images/x4/os_mandriva_x4.png</file>
+        <file alias="os_netbsd_64_x4.png">images/x4/os_netbsd_64_x4.png</file>
     </qresource>
 </RCC>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x3.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x3.qrc	(revision 72722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x3.qrc	(revision 72723)
@@ -1,17 +1,4 @@
 <RCC>
     <qresource suffix="/">
-        <file alias="os_l4_x3.png">images/x3/os_l4_x3.png</file>
-        <file alias="os_linux22_x3.png">images/x3/os_linux22_x3.png</file>
-        <file alias="os_linux24_64_x3.png">images/x3/os_linux24_64_x3.png</file>
-        <file alias="os_linux24_x3.png">images/x3/os_linux24_x3.png</file>
-        <file alias="os_linux26_64_x3.png">images/x3/os_linux26_64_x3.png</file>
-        <file alias="os_linux26_x3.png">images/x3/os_linux26_x3.png</file>
-        <file alias="os_linux_64_x3.png">images/x3/os_linux_64_x3.png</file>
-        <file alias="os_linux_x3.png">images/x3/os_linux_x3.png</file>
-        <file alias="os_macosx_64_x3.png">images/x3/os_macosx_64_x3.png</file>
-        <file alias="os_macosx_x3.png">images/x3/os_macosx_x3.png</file>
-        <file alias="os_mandriva_64_x3.png">images/x3/os_mandriva_64_x3.png</file>
-        <file alias="os_mandriva_x3.png">images/x3/os_mandriva_x3.png</file>
-        <file alias="os_netbsd_64_x3.png">images/x3/os_netbsd_64_x3.png</file>
         <file alias="os_netbsd_x3.png">images/x3/os_netbsd_x3.png</file>
         <file alias="os_netware_x3.png">images/x3/os_netware_x3.png</file>
@@ -77,4 +64,26 @@
         <file alias="preview_full_4to3_242x192px_x3.png">images/x3/preview_full_4to3_242x192px_x3.png</file>
         <file alias="previous_16px_x3.png">images/x3/previous_16px_x3.png</file>
+        <file alias="progress_clone_90px_x3.png">images/x3/progress_clone_90px_x3.png</file>
+        <file alias="progress_delete_90px_x3.png">images/x3/progress_delete_90px_x3.png</file>
+        <file alias="progress_dnd_gh_90px_x3.png">images/x3/progress_dnd_gh_90px_x3.png</file>
+        <file alias="progress_dnd_hg_90px_x3.png">images/x3/progress_dnd_hg_90px_x3.png</file>
+        <file alias="progress_export_90px_x3.png">images/x3/progress_export_90px_x3.png</file>
+        <file alias="progress_import_90px_x3.png">images/x3/progress_import_90px_x3.png</file>
+        <file alias="progress_install_guest_additions_90px_x3.png">images/x3/progress_install_guest_additions_90px_x3.png</file>
+        <file alias="progress_media_create_90px_x3.png">images/x3/progress_media_create_90px_x3.png</file>
+        <file alias="progress_media_delete_90px_x3.png">images/x3/progress_media_delete_90px_x3.png</file>
+        <file alias="progress_media_move_90px_x3.png">images/x3/progress_media_move_90px_x3.png</file>
+        <file alias="progress_media_resize_90px_x3.png">images/x3/progress_media_resize_90px_x3.png</file>
+        <file alias="progress_network_interface_90px_x3.png">images/x3/progress_network_interface_90px_x3.png</file>
+        <file alias="progress_poweroff_90px_x3.png">images/x3/progress_poweroff_90px_x3.png</file>
+        <file alias="progress_reading_appliance_90px_x3.png">images/x3/progress_reading_appliance_90px_x3.png</file>
+        <file alias="progress_refresh_90px_x3.png">images/x3/progress_refresh_90px_x3.png</file>
+        <file alias="progress_settings_90px_x3.png">images/x3/progress_settings_90px_x3.png</file>
+        <file alias="progress_snapshot_create_90px_x3.png">images/x3/progress_snapshot_create_90px_x3.png</file>
+        <file alias="progress_snapshot_discard_90px_x3.png">images/x3/progress_snapshot_discard_90px_x3.png</file>
+        <file alias="progress_snapshot_restore_90px_x3.png">images/x3/progress_snapshot_restore_90px_x3.png</file>
+        <file alias="progress_start_90px_x3.png">images/x3/progress_start_90px_x3.png</file>
+        <file alias="progress_state_restore_90px_x3.png">images/x3/progress_state_restore_90px_x3.png</file>
+        <file alias="progress_state_save_90px_x3.png">images/x3/progress_state_save_90px_x3.png</file>
         <file alias="proxy_16px_x3.png">images/x3/proxy_16px_x3.png</file>
         <file alias="proxy_24px_x3.png">images/x3/proxy_24px_x3.png</file>
@@ -87,4 +96,5 @@
         <file alias="refresh_32px_x3.png">images/x3/refresh_32px_x3.png</file>
         <file alias="refresh_disabled_16px_x3.png">images/x3/refresh_disabled_16px_x3.png</file>
+        <file alias="refresh_disabled_22px_x3.png">images/x3/refresh_disabled_22px_x3.png</file>
         <file alias="refresh_disabled_32px_x3.png">images/x3/refresh_disabled_32px_x3.png</file>
         <file alias="refresh_warning_16px_x3.png">images/x3/refresh_warning_16px_x3.png</file>
@@ -122,4 +132,5 @@
         <file alias="session_info_32px_x3.png">images/x3/session_info_32px_x3.png</file>
         <file alias="session_info_details_16px_x3.png">images/x3/session_info_details_16px_x3.png</file>
+        <file alias="session_info_disabled_16px_x3.png">images/x3/session_info_disabled_16px_x3.png</file>
         <file alias="session_info_runtime_16px_x3.png">images/x3/session_info_runtime_16px_x3.png</file>
         <file alias="sf_16px_x3.png">images/x3/sf_16px_x3.png</file>
@@ -190,4 +201,6 @@
         <file alias="statusbar_settings_16px_x3.png">images/x3/statusbar_settings_16px_x3.png</file>
         <file alias="statusbar_settings_disabled_16px_x3.png">images/x3/statusbar_settings_disabled_16px_x3.png</file>
+        <file alias="tools_banner_global_200px_x3.png">images/x3/tools_banner_global_200px_x3.png</file>
+        <file alias="tools_banner_machine_200px_x3.png">images/x3/tools_banner_machine_200px_x3.png</file>
         <file alias="tools_global_32px_x3.png">images/x3/tools_global_32px_x3.png</file>
         <file alias="tools_machine_32px_x3.png">images/x3/tools_machine_32px_x3.png</file>
@@ -288,4 +301,5 @@
         <file alias="web_camera_unavailable_16px_x3.png">images/x3/web_camera_unavailable_16px_x3.png</file>
         <file alias="web_camera_unavailable_disabled_16px_x3.png">images/x3/web_camera_unavailable_disabled_16px_x3.png</file>
+        <file alias="welcome_200px_x3.png">images/x3/welcome_200px_x3.png</file>
         <file alias="wizard_clone_x3.png">images/x3/wizard_clone_x3.png</file>
         <file alias="wizard_first_run_x3.png">images/x3/wizard_first_run_x3.png</file>
Index: trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x4.qrc
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x4.qrc	(revision 72722)
+++ trunk/src/VBox/Frontends/VirtualBox/VirtualBox2_x4.qrc	(revision 72723)
@@ -1,17 +1,4 @@
 <RCC>
     <qresource suffix="/">
-        <file alias="os_l4_x4.png">images/x4/os_l4_x4.png</file>
-        <file alias="os_linux22_x4.png">images/x4/os_linux22_x4.png</file>
-        <file alias="os_linux24_64_x4.png">images/x4/os_linux24_64_x4.png</file>
-        <file alias="os_linux24_x4.png">images/x4/os_linux24_x4.png</file>
-        <file alias="os_linux26_64_x4.png">images/x4/os_linux26_64_x4.png</file>
-        <file alias="os_linux26_x4.png">images/x4/os_linux26_x4.png</file>
-        <file alias="os_linux_64_x4.png">images/x4/os_linux_64_x4.png</file>
-        <file alias="os_linux_x4.png">images/x4/os_linux_x4.png</file>
-        <file alias="os_macosx_64_x4.png">images/x4/os_macosx_64_x4.png</file>
-        <file alias="os_macosx_x4.png">images/x4/os_macosx_x4.png</file>
-        <file alias="os_mandriva_64_x4.png">images/x4/os_mandriva_64_x4.png</file>
-        <file alias="os_mandriva_x4.png">images/x4/os_mandriva_x4.png</file>
-        <file alias="os_netbsd_64_x4.png">images/x4/os_netbsd_64_x4.png</file>
         <file alias="os_netbsd_x4.png">images/x4/os_netbsd_x4.png</file>
         <file alias="os_netware_x4.png">images/x4/os_netware_x4.png</file>
@@ -77,4 +64,26 @@
         <file alias="preview_full_4to3_242x192px_x4.png">images/x4/preview_full_4to3_242x192px_x4.png</file>
         <file alias="previous_16px_x4.png">images/x4/previous_16px_x4.png</file>
+        <file alias="progress_clone_90px_x4.png">images/x4/progress_clone_90px_x4.png</file>
+        <file alias="progress_delete_90px_x4.png">images/x4/progress_delete_90px_x4.png</file>
+        <file alias="progress_dnd_gh_90px_x4.png">images/x4/progress_dnd_gh_90px_x4.png</file>
+        <file alias="progress_dnd_hg_90px_x4.png">images/x4/progress_dnd_hg_90px_x4.png</file>
+        <file alias="progress_export_90px_x4.png">images/x4/progress_export_90px_x4.png</file>
+        <file alias="progress_import_90px_x4.png">images/x4/progress_import_90px_x4.png</file>
+        <file alias="progress_install_guest_additions_90px_x4.png">images/x4/progress_install_guest_additions_90px_x4.png</file>
+        <file alias="progress_media_create_90px_x4.png">images/x4/progress_media_create_90px_x4.png</file>
+        <file alias="progress_media_delete_90px_x4.png">images/x4/progress_media_delete_90px_x4.png</file>
+        <file alias="progress_media_move_90px_x4.png">images/x4/progress_media_move_90px_x4.png</file>
+        <file alias="progress_media_resize_90px_x4.png">images/x4/progress_media_resize_90px_x4.png</file>
+        <file alias="progress_network_interface_90px_x4.png">images/x4/progress_network_interface_90px_x4.png</file>
+        <file alias="progress_poweroff_90px_x4.png">images/x4/progress_poweroff_90px_x4.png</file>
+        <file alias="progress_reading_appliance_90px_x4.png">images/x4/progress_reading_appliance_90px_x4.png</file>
+        <file alias="progress_refresh_90px_x4.png">images/x4/progress_refresh_90px_x4.png</file>
+        <file alias="progress_settings_90px_x4.png">images/x4/progress_settings_90px_x4.png</file>
+        <file alias="progress_snapshot_create_90px_x4.png">images/x4/progress_snapshot_create_90px_x4.png</file>
+        <file alias="progress_snapshot_discard_90px_x4.png">images/x4/progress_snapshot_discard_90px_x4.png</file>
+        <file alias="progress_snapshot_restore_90px_x4.png">images/x4/progress_snapshot_restore_90px_x4.png</file>
+        <file alias="progress_start_90px_x4.png">images/x4/progress_start_90px_x4.png</file>
+        <file alias="progress_state_restore_90px_x4.png">images/x4/progress_state_restore_90px_x4.png</file>
+        <file alias="progress_state_save_90px_x4.png">images/x4/progress_state_save_90px_x4.png</file>
         <file alias="proxy_16px_x4.png">images/x4/proxy_16px_x4.png</file>
         <file alias="proxy_24px_x4.png">images/x4/proxy_24px_x4.png</file>
@@ -87,4 +96,5 @@
         <file alias="refresh_32px_x4.png">images/x4/refresh_32px_x4.png</file>
         <file alias="refresh_disabled_16px_x4.png">images/x4/refresh_disabled_16px_x4.png</file>
+        <file alias="refresh_disabled_22px_x4.png">images/x4/refresh_disabled_22px_x4.png</file>
         <file alias="refresh_disabled_32px_x4.png">images/x4/refresh_disabled_32px_x4.png</file>
         <file alias="refresh_warning_16px_x4.png">images/x4/refresh_warning_16px_x4.png</file>
@@ -122,4 +132,5 @@
         <file alias="session_info_32px_x4.png">images/x4/session_info_32px_x4.png</file>
         <file alias="session_info_details_16px_x4.png">images/x4/session_info_details_16px_x4.png</file>
+        <file alias="session_info_disabled_16px_x4.png">images/x4/session_info_disabled_16px_x4.png</file>
         <file alias="session_info_runtime_16px_x4.png">images/x4/session_info_runtime_16px_x4.png</file>
         <file alias="sf_16px_x4.png">images/x4/sf_16px_x4.png</file>
@@ -190,4 +201,6 @@
         <file alias="statusbar_settings_16px_x4.png">images/x4/statusbar_settings_16px_x4.png</file>
         <file alias="statusbar_settings_disabled_16px_x4.png">images/x4/statusbar_settings_disabled_16px_x4.png</file>
+        <file alias="tools_banner_global_200px_x4.png">images/x4/tools_banner_global_200px_x4.png</file>
+        <file alias="tools_banner_machine_200px_x4.png">images/x4/tools_banner_machine_200px_x4.png</file>
         <file alias="tools_global_32px_x4.png">images/x4/tools_global_32px_x4.png</file>
         <file alias="tools_machine_32px_x4.png">images/x4/tools_machine_32px_x4.png</file>
@@ -288,4 +301,5 @@
         <file alias="web_camera_unavailable_16px_x4.png">images/x4/web_camera_unavailable_16px_x4.png</file>
         <file alias="web_camera_unavailable_disabled_16px_x4.png">images/x4/web_camera_unavailable_disabled_16px_x4.png</file>
+        <file alias="welcome_200px_x4.png">images/x4/welcome_200px_x4.png</file>
         <file alias="wizard_clone_x4.png">images/x4/wizard_clone_x4.png</file>
         <file alias="wizard_first_run_x4.png">images/x4/wizard_first_run_x4.png</file>