Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 73030)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 73033)
@@ -55,4 +55,6 @@
     , m_pProviderComboBoxLabel(0)
     , m_pProviderComboBox(0)
+    , m_pProfileComboBoxLabel(0)
+    , m_pProfileComboBox(0)
 {
 }
@@ -100,4 +102,22 @@
 }
 
+void UIWizardExportAppPage3::populateProfiles()
+{
+    /* Acquire profile list: */
+    // Here goes the experiamental list with
+    // arbitrary contents for testing purposes.
+    QStringList profiles;
+    profiles << "Profile 1";
+    profiles << "Profile 2";
+    profiles << "Profile 3";
+    profiles << "Profile 4";
+    m_pProfileComboBox->clear();
+    m_pProfileComboBox->addItems(profiles);
+
+    /* Duplicate non-translated names to data fields: */
+    for (int i = 0; i < m_pProfileComboBox->count(); ++i)
+        m_pProfileComboBox->setItemData(i, m_pProfileComboBox->itemText(i));
+}
+
 void UIWizardExportAppPage3::updatePageAppearance()
 {
@@ -234,4 +254,17 @@
     AssertMsg(iIndex != -1, ("Field not found!"));
     m_pProviderComboBox->setCurrentIndex(iIndex);
+}
+
+QString UIWizardExportAppPage3::profile() const
+{
+    const int iIndex = m_pProfileComboBox->currentIndex();
+    return m_pProfileComboBox->itemData(iIndex).toString();
+}
+
+void UIWizardExportAppPage3::setProfile(const QString &strProfile)
+{
+    const int iIndex = m_pProfileComboBox->findData(strProfile);
+    AssertMsg(iIndex != -1, ("Field not found!"));
+    m_pProfileComboBox->setCurrentIndex(iIndex);
 }
 
@@ -372,4 +405,22 @@
                     }
 
+                    /* Create profile combo-box: */
+                    m_pProfileComboBox = new QComboBox;
+                    if (m_pProfileComboBox)
+                    {
+                        /* Add into layout: */
+                        pSettingsLayout2->addWidget(m_pProfileComboBox, 1, 1);
+                    }
+                    /* Create profile label: */
+                    m_pProfileComboBoxLabel = new QLabel;
+                    if (m_pProfileComboBoxLabel)
+                    {
+                        m_pProfileComboBoxLabel->setAlignment(Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter);
+                        m_pProfileComboBoxLabel->setBuddy(m_pProviderComboBox);
+
+                        /* Add into layout: */
+                        pSettingsLayout2->addWidget(m_pProfileComboBoxLabel, 1, 0);
+                    }
+
                     /* Create placeholder: */
                     QWidget *pPlaceholder = new QWidget;
@@ -377,5 +428,5 @@
                     {
                         /* Add into layout: */
-                        pSettingsLayout2->addWidget(pPlaceholder, 1, 0, 1, 2);
+                        pSettingsLayout2->addWidget(pPlaceholder, 2, 0, 1, 2);
                     }
                 }
@@ -397,4 +448,6 @@
     /* Populate providers: */
     populateProviders();
+    /* Populate profiles: */
+    populateProfiles();
 
     /* Setup connections: */
@@ -404,4 +457,6 @@
     connect(m_pProviderComboBox, static_cast<void(QComboBox::*)(int)>(&QComboBox::currentIndexChanged),
             this, &UIWizardExportAppPageBasic3::sltHandleProviderComboChange);
+    connect(m_pProfileComboBox, static_cast<void(QComboBox::*)(int)>(&QComboBox::currentIndexChanged),
+            this, &UIWizardExportAppPageBasic3::sltHandleProfileComboChange);
 
     /* Register fields: */
@@ -455,4 +510,7 @@
         }
     }
+
+    /* Translate Profile combo-box: */
+    m_pProfileComboBoxLabel->setText(UIWizardExportApp::tr("&Profile:"));
 
     /* Refresh file selector name: */
@@ -561,3 +619,10 @@
     /* Update tool-tip: */
     updateProviderComboToolTip();
-}
+
+    /* Refresh required settings: */
+    populateProfiles();
+}
+
+void UIWizardExportAppPageBasic3::sltHandleProfileComboChange()
+{
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.h	(revision 73030)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.h	(revision 73033)
@@ -47,4 +47,6 @@
     /** Populates providers. */
     void populateProviders();
+    /** Populates profiles. */
+    void populateProfiles();
 
     /** Updates page appearance. */
@@ -85,4 +87,9 @@
     void setProvider(const QString &strProvider);
 
+    /** Returns profile. */
+    QString profile() const;
+    /** Defines @a strProfile. */
+    void setProfile(const QString &strProfile);
+
     /** Holds the default appliance name. */
     QString  m_strDefaultApplianceName;
@@ -115,4 +122,9 @@
     /** Holds the provider combo-box instance. */
     QComboBox *m_pProviderComboBox;
+
+    /** Holds the profile combo-box label instance. */
+    QLabel    *m_pProfileComboBoxLabel;
+    /** Holds the profile combo-box instance. */
+    QComboBox *m_pProfileComboBox;
 };
 
@@ -157,4 +169,7 @@
     void sltHandleProviderComboChange();
 
+    /** Handles change in profile combo-box. */
+    void sltHandleProfileComboChange();
+
 private:
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 73030)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 73033)
@@ -268,4 +268,22 @@
                             }
 
+                            /* Create profile combo-box: */
+                            m_pProfileComboBox = new QComboBox;
+                            if (m_pProfileComboBox)
+                            {
+                                /* Add into layout: */
+                                pSettingsLayout2->addWidget(m_pProfileComboBox, 1, 1);
+                            }
+                            /* Create profile label: */
+                            m_pProfileComboBoxLabel = new QLabel;
+                            if (m_pProfileComboBoxLabel)
+                            {
+                                m_pProfileComboBoxLabel->setAlignment(Qt::AlignRight|Qt::AlignTrailing|Qt::AlignVCenter);
+                                m_pProfileComboBoxLabel->setBuddy(m_pProviderComboBox);
+
+                                /* Add into layout: */
+                                pSettingsLayout2->addWidget(m_pProfileComboBoxLabel, 1, 0);
+                            }
+
                             /* Create placeholder: */
                             QWidget *pPlaceholder = new QWidget;
@@ -273,5 +291,5 @@
                             {
                                 /* Add into layout: */
-                                pSettingsLayout2->addWidget(pPlaceholder, 1, 0, 1, 2);
+                                pSettingsLayout2->addWidget(pPlaceholder, 2, 0, 1, 2);
                             }
                         }
@@ -299,4 +317,6 @@
     /* Populate providers: */
     populateProviders();
+    /* Populate profiles: */
+    populateProfiles();
 
     /* Setup connections: */
@@ -309,4 +329,6 @@
     connect(m_pProviderComboBox, static_cast<void(QComboBox::*)(int)>(&QComboBox::currentIndexChanged),
             this, &UIWizardExportAppPageExpert::sltHandleProviderComboChange);
+    connect(m_pProfileComboBox, static_cast<void(QComboBox::*)(int)>(&QComboBox::currentIndexChanged),
+            this, &UIWizardExportAppPageExpert::sltHandleProfileComboChange);
 
     /* Register classes: */
@@ -375,4 +397,7 @@
         }
     }
+
+    /* Translate Profile combo-box: */
+    m_pProfileComboBoxLabel->setText(UIWizardExportApp::tr("&Profile:"));
 
     /* Refresh file selector name: */
@@ -489,3 +514,10 @@
     /* Update tool-tip: */
     updateProviderComboToolTip();
-}
+
+    /* Refresh required settings: */
+    populateProfiles();
+}
+
+void UIWizardExportAppPageExpert::sltHandleProfileComboChange()
+{
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.h	(revision 73030)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.h	(revision 73033)
@@ -87,4 +87,7 @@
     void sltHandleProviderComboChange();
 
+    /** Handles change in profile combo-box. */
+    void sltHandleProfileComboChange();
+
 private:
 