Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 73232)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageBasic3.cpp	(revision 73233)
@@ -425,4 +425,5 @@
 
 UIWizardExportAppPageBasic3::UIWizardExportAppPageBasic3()
+    : m_pLabel(0)
 {
     /* Create main layout: */
@@ -450,5 +451,11 @@
                 if (pSettingsLayout1)
                 {
-                    pSettingsLayout1->setContentsMargins(0, 0, 0, 0);
+#ifdef VBOX_WS_MAC
+                    pSettingsLayout1->setContentsMargins(0, 10, 0, 10);
+                    pSettingsLayout1->setSpacing(10);
+#else
+                    pSettingsLayout1->setContentsMargins(0, qApp->style()->pixelMetric(QStyle::PM_LayoutTopMargin),
+                                                         0, qApp->style()->pixelMetric(QStyle::PM_LayoutBottomMargin));
+#endif
                     pSettingsLayout1->setColumnStretch(0, 0);
                     pSettingsLayout1->setColumnStretch(1, 1);
@@ -464,5 +471,5 @@
 
                         /* Add into layout: */
-                        pSettingsLayout1->addWidget(m_pFileSelector, 0, 1);
+                        pSettingsLayout1->addWidget(m_pFileSelector, 0, 1, 1, 2);
                     }
                     /* Create file selector label: */
@@ -482,5 +489,5 @@
                     {
                         /* Add into layout: */
-                        pSettingsLayout1->addWidget(m_pFormatComboBox, 1, 1);
+                        pSettingsLayout1->addWidget(m_pFormatComboBox, 1, 1, 1, 2);
                     }
                     /* Create format combo-box label: */
@@ -500,5 +507,5 @@
                     {
                         /* Add into layout: */
-                        pSettingsLayout1->addWidget(m_pMACComboBox, 2, 1);
+                        pSettingsLayout1->addWidget(m_pMACComboBox, 2, 1, 1, 2);
                     }
                     /* Create format combo-box label: */
@@ -542,5 +549,5 @@
                     {
                         /* Add into layout: */
-                        pSettingsLayout1->addWidget(pPlaceholder, 5, 0, 1, 2);
+                        pSettingsLayout1->addWidget(pPlaceholder, 5, 0, 1, 3);
                     }
                 }
@@ -558,5 +565,12 @@
                 if (pSettingsLayout2)
                 {
-                    pSettingsLayout2->setContentsMargins(0, 0, 0, 0);
+#ifdef VBOX_WS_MAC
+                    pSettingsLayout2->setContentsMargins(0, 10, 0, 10);
+                    pSettingsLayout2->setSpacing(10);
+
+#else
+                    pSettingsLayout2->setContentsMargins(0, qApp->style()->pixelMetric(QStyle::PM_LayoutTopMargin),
+                                                         0, qApp->style()->pixelMetric(QStyle::PM_LayoutBottomMargin));
+#endif
                     pSettingsLayout2->setColumnStretch(0, 0);
                     pSettingsLayout2->setColumnStretch(1, 1);
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 73232)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/exportappliance/UIWizardExportAppPageExpert.cpp	(revision 73233)
@@ -149,4 +149,7 @@
             {
                 pSettingsCntLayout->setContentsMargins(0, 0, 0, 0);
+#ifdef VBOX_WS_MAC
+                pSettingsCntLayout->setSpacing(5);
+#endif
 
                 /* Create settings widget: */
@@ -162,4 +165,8 @@
                         if (pSettingsLayout1)
                         {
+#ifdef VBOX_WS_MAC
+                            pSettingsLayout1->setSpacing(10);
+#endif
+                            pSettingsLayout1->setContentsMargins(0, 0, 0, 0);
                             pSettingsLayout1->setColumnStretch(0, 0);
                             pSettingsLayout1->setColumnStretch(1, 1);
@@ -175,5 +182,5 @@
 
                                 /* Add into layout: */
-                                pSettingsLayout1->addWidget(m_pFileSelector, 0, 1);
+                                pSettingsLayout1->addWidget(m_pFileSelector, 0, 1, 1, 2);
                             }
                             /* Create file selector label: */
@@ -193,5 +200,5 @@
                             {
                                 /* Add into layout: */
-                                pSettingsLayout1->addWidget(m_pFormatComboBox, 1, 1);
+                                pSettingsLayout1->addWidget(m_pFormatComboBox, 1, 1, 1, 2);
                             }
                             /* Create format combo-box label: */
@@ -211,5 +218,5 @@
                             {
                                 /* Add into layout: */
-                                pSettingsLayout1->addWidget(m_pMACComboBox, 2, 1);
+                                pSettingsLayout1->addWidget(m_pMACComboBox, 2, 1, 1, 2);
                             }
                             /* Create format combo-box label: */
@@ -253,5 +260,5 @@
                             {
                                 /* Add into layout: */
-                                pSettingsLayout1->addWidget(pPlaceholder, 5, 0, 1, 2);
+                                pSettingsLayout1->addWidget(pPlaceholder, 5, 0, 1, 3);
                             }
                         }
@@ -269,4 +276,8 @@
                         if (pSettingsLayout2)
                         {
+#ifdef VBOX_WS_MAC
+                            pSettingsLayout2->setSpacing(10);
+#endif
+                            pSettingsLayout2->setContentsMargins(0, 0, 0, 0);
                             pSettingsLayout2->setColumnStretch(0, 0);
                             pSettingsLayout2->setColumnStretch(1, 1);
@@ -311,5 +322,5 @@
                                 m_pAccountPropertyTable->verticalHeader()->setSectionResizeMode(QHeaderView::ResizeToContents);
 
-                                    /* Add into layout: */
+                                /* Add into layout: */
                                 pSettingsLayout2->addWidget(m_pAccountPropertyTable, 1, 1);
                             }